<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 02.04.2015
 */
namespace skeeks\modules\cms\shop\components\shop;
use skeeks\cms\helpers\UrlHelper;
use skeeks\modules\cms\shop\components\Cart;
use skeeks\modules\cms\shop\models\ShopPersonType;
use yii\helpers\ArrayHelper;

/**
 * Class Shop
 * @package skeeks\modules\cms\shop\components
 */
class Shop extends \skeeks\cms\base\Component
{
    /**
     * @var string E-Mail администратора сайта (отправитель по умолчанию).
     */
    public $email                  = 'admin@skeeks.com';

    /**
     * @var int
     */
    public $allowBuyWhithoutQuantity                  = 1;

    /**
     * @var Cart
     */
    public $cart = null;

    public function init()
    {
        parent::init();
        $this->cart = new Cart();
    }
    /**
     * Можно задать название и описание компонента
     * @return array
     */
    static public function getDescriptorConfig()
    {
        return
        [
            'name'                              => 'Интернет-магазин',

        ];
    }

    public function rules()
    {
        return ArrayHelper::merge(parent::rules(), [
            [['email'], 'email'],
            [['allowBuyWhithoutQuantity'], 'integer'],
        ]);
    }

    public function attributeLabels()
    {
        return ArrayHelper::merge(parent::attributeLabels(), [
            'email'                             => 'Email отдела продаж',
            'allowBuyWhithoutQuantity'          => 'Разрешить покупку при отсутствии товара',
        ]);
    }


    /**
     * Опции для js.
     *
     * @return array
     */
    public function getShopClientOptions()
    {
        return [
            'backend-add-product' => UrlHelper::construct('shop/basket/add-product')->toString(),
            'backend-remove-basket' => UrlHelper::construct('shop/basket/remove-basket')->toString(),
            'backend-update-basket' => UrlHelper::construct('shop/basket/update-basket')->toString(),
            'backend-clear' => UrlHelper::construct('shop/basket/clear-all')->toString()
        ];
    }

    /**
     * Активные типы платежных пользователей.
     *
     * @return ShopPersonType[]
     */
    public function getPersonTypes()
    {
        return ShopPersonType::find()->where(['active' => 1])->all();
    }


}