<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 03.04.2015
 */
namespace skeeks\modules\cms\shop\controllers;

use skeeks\cms\base\Controller;
use skeeks\cms\helpers\RequestResponse;
use skeeks\modules\cms\shop\models\ShopBasket;
use skeeks\modules\cms\shop\models\ShopFuser;
use skeeks\modules\cms\catalog\models\Product;
use skeeks\modules\cms\shop\models\ShopOrder;
use yii\base\UserException;

/**
 * Class OrderController
 * @package skeeks\modules\cms\shop\controllers
 */
class OrderController extends Controller
{
    /**
     * @return array|\yii\web\Response
     */
    public function actionView()
    {
        if (!$id = (int) \Yii::$app->request->get('id'))
        {
            throw new UserException("Заказ не найден");
        }

        if (!$shopOrder = ShopOrder::findOne($id))
        {
            throw new UserException("Заказ не найден");
        }

        return $this->render('view', [
            'model' => $shopOrder
        ]);
    }
}