<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 01.04.2015
 */
use yii\db\Schema;
use yii\db\Migration;

class m150401_100558_create_table__shop_fuser extends Migration
{
    public function safeUp()
    {
        $tableExist = $this->db->getTableSchema("{{%shop_fuser}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%shop_fuser}}", [
            'id'                    => Schema::TYPE_PK,

            'created_by'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_by'            => Schema::TYPE_INTEGER . ' NULL',

            'created_at'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_at'            => Schema::TYPE_INTEGER . ' NULL',

            'user_id'               => Schema::TYPE_INTEGER . ' NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%shop_fuser}} ADD INDEX(updated_by);");
        $this->execute("ALTER TABLE {{%shop_fuser}} ADD INDEX(created_by);");

        $this->execute("ALTER TABLE {{%shop_fuser}} ADD INDEX(created_at);");
        $this->execute("ALTER TABLE {{%shop_fuser}} ADD INDEX(updated_at);");
        $this->execute("ALTER TABLE {{%shop_fuser}} ADD UNIQUE(user_id);");

        $this->execute("ALTER TABLE {{%shop_fuser}} COMMENT = 'Пользователи для корзины';");

        $this->addForeignKey(
            'shop_fuser_created_by', "{{%shop_fuser}}",
            'created_by', '{{%cms_user}}', 'id', 'SET NULL', 'SET NULL'
        );

        $this->addForeignKey(
            'shop_fuser_updated_by', "{{%shop_fuser}}",
            'updated_by', '{{%cms_user}}', 'id', 'SET NULL', 'SET NULL'
        );

        $this->addForeignKey(
            'shop_fuser_user_id', "{{%shop_fuser}}",
            'user_id', '{{%cms_user}}', 'id', 'SET NULL', 'SET NULL'
        );

    }

    public function safeDown()
    {
        $this->dropForeignKey("shop_fuser_updated_by", "{{%shop_fuser}}");
        $this->dropForeignKey("shop_fuser_updated_by", "{{%shop_fuser}}");

        $this->dropTable("{{%shop_fuser}}");
    }
}
