<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 01.04.2015
 */
use yii\db\Schema;
use yii\db\Migration;

class m150401_100559_create_table__shop_order_status extends Migration
{
    public function safeUp()
    {
        $tableExist = $this->db->getTableSchema("{{%shop_order_status}}", true);
        if ($tableExist)
        {
            return true;
        }

        $tableOptions = null;
        if ($this->db->driverName === 'mysql') {
            $tableOptions = 'CHARACTER SET utf8 COLLATE utf8_general_ci ENGINE=InnoDB';
        }

        $this->createTable("{{%shop_order_status}}", [
            'id'                    => Schema::TYPE_PK,

            'created_by'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_by'            => Schema::TYPE_INTEGER . ' NULL',

            'created_at'            => Schema::TYPE_INTEGER . ' NULL',
            'updated_at'            => Schema::TYPE_INTEGER . ' NULL',

            'code'                  => 'char(1) NOT NULL',

            'name'                  => Schema::TYPE_STRING . '(255) NOT NULL',
            'description'           => Schema::TYPE_TEXT . ' NULL',
            'priority'              => Schema::TYPE_INTEGER . ' NOT NULL DEFAULT 0',

            'color'                 => Schema::TYPE_STRING . '(32) NULL',

        ], $tableOptions);

        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(updated_by);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(created_by);");

        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(created_at);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(updated_at);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(name);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(priority);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD INDEX(color);");
        $this->execute("ALTER TABLE {{%shop_order_status}} ADD UNIQUE(code);");

        $this->execute("ALTER TABLE {{%shop_order_status}} COMMENT = 'Статусы заказов';");

        $this->addForeignKey(
            'shop_order_status_created_by', "{{%shop_order_status}}",
            'created_by', '{{%cms_user}}', 'id', 'SET NULL', 'SET NULL'
        );

        $this->addForeignKey(
            'shop_order_status_updated_by', "{{%shop_order_status}}",
            'updated_by', '{{%cms_user}}', 'id', 'SET NULL', 'SET NULL'
        );

    }

    public function safeDown()
    {
        $this->dropForeignKey("shop_order_status_updated_by", "{{%shop_order_status}}");
        $this->dropForeignKey("shop_order_status_updated_by", "{{%shop_order_status}}");

        $this->dropTable("{{%shop_order_status}}");
    }
}
