<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 14.04.2015
 */
/* @var $widget \skeeks\modules\cms\shop\widgets\order\OrderWidget */
/* @var $model \skeeks\modules\cms\shop\models\ShopOrder */
/* @var $this \yii\web\View */

use yii\helpers\Html;
use skeeks\cms\modules\admin\widgets\form\ActiveFormUseTab as ActiveForm;

?>

<?php $form = ActiveForm::begin(); ?>

<?= $form->fieldSet('Карточка заказа'); ?>


<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Заказ №<?= $model->id; ?> от <?= \Yii::$app->formatter->asDatetime($model->created_at); ?> (<?= \Yii::$app->formatter->asRelativeTime($model->created_at); ?>)</th>
    </tr>
    <tr>
        <td width="40%">Заказ №:</td>
        <td><?= $model->id; ?></td>
    </tr>
    <tr>
        <td width="40%">Создан:</td>
        <td><?= \Yii::$app->formatter->asDatetime($model->created_at); ?> <small>(<?= \Yii::$app->formatter->asRelativeTime($model->created_at); ?>)</small></td>
    </tr>
    <tr>
        <td width="40%">Текущий статус заказа:</td>
        <td><?= $model->statusCode->name; ?> <br /><small><?= \Yii::$app->formatter->asDatetime($model->status_at); ?> (<?= \Yii::$app->formatter->asRelativeTime($model->status_at); ?>)</small></td>
    </tr>
    <tr>
        <td>Сумма заказа:</td>
        <td><?= \Yii::$app->money->intlFormatter()->format($model->price()); ?></td>
    </tr>
    <tr>
        <td>Отменен:</td>
        <td>
            <? if($model->canceled) : ?>
                Да
                <br />
                <small><?= \Yii::$app->formatter->asDatetime($model->canceled_at); ?> (<?= \Yii::$app->formatter->asRelativeTime($model->canceled_at); ?>)</small>
                <br />
                <p><b>Прчина:</b> <?= $model->reason_canceled; ?></p>
            <? else:  ?>
                Нет
            <? endif;  ?>
        </td>
    </tr>
</table>

<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Данные учетной записи</th>
    </tr>
    <tr>
        <td width="40%">Учетная запись:</td>
        <td><?= $model->user->getDisplayName(); ?></td>
    </tr>
    <tr>
        <td>Логин:</td>
        <td><?= $model->user->username; ?></td>
    </tr>
    <tr>
        <td>E-Mail адрес:</td>
        <td><?= $model->user->email; ?></td>
    </tr>
</table>

<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Параметры заказа</th>
    </tr>
    <tr>
        <td width="40%">Тип плательщика:</td>
        <td><?= $model->personType->name; ?></td>
    </tr>
    <? if ($model->data) : ?>
        <? foreach ($model->data as $key => $value) : ?>
            <tr>
                <td width="40%"><?= $key; ?>:</td>
                <td><?= $value; ?></td>
            </tr>
        <? endforeach;  ?>
    <? endif; ?>
</table>

<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Оплата и доставка</th>
    </tr>
    <tr>
        <td width="40%">Платежная система:</td>
        <td><?= $model->paySystem->name; ?></td>
    </tr>
    <tr>
        <td>Оплачен:</td>
        <td>
            <? if($model->payed) : ?>
                Да <br /><small><?= \Yii::$app->formatter->asDatetime($model->payed_at); ?> (<?= \Yii::$app->formatter->asRelativeTime($model->payed_at); ?>)</small>
            <? else:  ?>
                Нет
            <? endif;  ?>
        </td>
    </tr>
</table>

<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Служба доставки</th>
    </tr>
    <tr>
        <td width="40%">Служба доставки:</td>
        <td>Не используется</td>
    </tr>
</table>

<table class="table table-striped table-bordered">
    <tr>
        <th colspan="2">Содержимое заказа</th>
    </tr>
    <tr>
        <td>
            <?
            $this->registerCss(<<<CSS
    .sx-basket-table table img.img-thumbnail
    {
        max-width: 110px;
    }
CSS
);
            ?>
            <div class="sx-basket-table">
            <?=
                \skeeks\cms\modules\admin\widgets\GridView::widget([
                    "dataProvider" => new \yii\data\ArrayDataProvider([
                        'allModels' => \skeeks\modules\cms\shop\models\ShopBasket::find()->where(['order_id' => $model->id])->all()
                    ]),
                    'layout' => '{items}',
                    'columns' =>
                    [
                        [
                            'class'     => \yii\grid\DataColumn::className(),
                            'value'     => function(\skeeks\modules\cms\shop\models\ShopBasket $model)
                            {
                                $product    = $model->product();
                                $pageUrl    = $product->getPageUrl();
                                $name       = $product->name;

                                $imageUrl = skeeks\cms\helpers\Image::getSrc($product->getMainImageSrc());


                                return <<<HTML
<a href="{$pageUrl}" style="text-align: center;">
    <img src="{$imageUrl}" alt="{$name}" title="{$name}" class="img-thumbnail">
</a>
HTML;
                            },
                            'format' => 'html',
                            'label' => 'Фото'
                        ],

                        [
                            'class'     => \yii\grid\DataColumn::className(),
                            'value'     => function(\skeeks\modules\cms\shop\models\ShopBasket $model)
                            {
                                return \yii\helpers\Html::a($model->name, $model->product()->getPageUrl());
                            },
                            'format' => 'html',
                            'label' => 'Товар'
                        ],

                        [
                            'class'     => \yii\grid\DataColumn::className(),
                            'value'     => function(\skeeks\modules\cms\shop\models\ShopBasket $model)
                            {
                                return $model->quantity;

                            },
                            'format' => 'raw',
                            'label' => 'Количество'
                        ],

                        [
                            'class'     => \yii\grid\DataColumn::className(),
                            'value'     => function(\skeeks\modules\cms\shop\models\ShopBasket $model)
                            {
                                return \Yii::$app->money->intlFormatter()->format($model->product()->cost());
                            },
                            'format' => 'html',
                            'label' => 'Цена товара'
                        ],

                        [
                            'class'     => \yii\grid\DataColumn::className(),
                            'value'     => function(\skeeks\modules\cms\shop\models\ShopBasket $model)
                            {
                                return \Yii::$app->money->intlFormatter()->format($model->price());
                            },
                            'format' => 'html',
                            'label' => 'Всего'
                        ],

                    ]
                ]);
            ?>
            </div>
        </td>
    </tr>
</table>


<?= $form->fieldSetEnd(); ?>

<?= $form->fieldSet('Управление'); ?>

    <?= $form->field($model, 'status_code')->widget(
        \skeeks\widget\chosen\Chosen::className(),
        [
            'allowDeselect' => false,
            'items' => \yii\helpers\ArrayHelper::map(
                \skeeks\modules\cms\shop\models\ShopOrderStatus::find()->all(),
                'code',
                'name'
            )
        ]
    ) ?>

    <?= $form->field($model, 'payed')->radioList(
        \Yii::$app->formatter->booleanFormat
    ) ?>

    <?= $form->field($model, 'allow_delivery')->radioList(
        \Yii::$app->formatter->booleanFormat
    ) ?>

    <?= $form->field($model, 'canceled')->widget(
        \skeeks\widget\chosen\Chosen::className(),
        [
            'allowDeselect' => false,
            'items' => \Yii::$app->formatter->booleanFormat
        ]
    ) ?>

    <div class="" id="rejected-text-wrapper" style="display: none;">
        <?= $form->field($model, 'reason_canceled')->textarea(['rows' => 3]); ?>
    </div>

<?
                $rejected = 1;

                $this->registerJs(<<<JS
                (function(sx, $, _)
                {
                    sx.classes.ProjectConferenceStatus = sx.classes.Component.extend({

                        _init: function()
                        {

                        },

                        _onDomReady: function()
                        {
                            var self = this;

                            $("#shoporder-canceled").on('change', function()
                            {
                                self.update();
                            });

                            self.update();
                        },

                        _onWindowReady: function()
                        {},

                        update: function()
                        {
                            var self = this;

                            if ($("#shoporder-canceled").val() == self.get('rejected'))
                            {
                                $("#rejected-text-wrapper").show();
                            } else
                            {
                                $("#rejected-text-wrapper").hide();
                            }
                        }
                    });

                    new sx.classes.ProjectConferenceStatus({
                        'rejected' : {$rejected}
                    });
                })(sx, sx.$, sx._);
JS
);?>



<?= $form->fieldSetEnd(); ?>

<?= $form->buttonsCreateOrUpdate($model); ?>
<?php ActiveForm::end(); ?>


