<?php
/**
 * index
 *
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010-2014 SkeekS (Sx)
 * @date 30.10.2014
 * @since 1.0.0
 */
use skeeks\cms\modules\admin\widgets\GridView;

/* @var $this yii\web\View */
/* @var $searchModel common\models\searchs\Game */
/* @var $dataProvider yii\data\ActiveDataProvider */

$dataProvider->sort->defaultOrder = ['id' => SORT_DESC];
?>

<?= GridView::widget([
    'dataProvider'  => $dataProvider,
    'filterModel'   => $searchModel,
    'columns' => [
        [
            'class'         => \skeeks\cms\modules\admin\grid\ActionColumn::className(),
            'controller'    => $controller
        ],

        [
            'class' => \skeeks\cms\grid\CreatedAtColumn::className(),
        ],

        [
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function(\skeeks\modules\cms\shop\models\ShopOrder $model)
            {
                return "№" . $model->id;
            },
            'label'     => 'Номер заказа',
            'attribute' => 'id',
            //'filter'    => \yii\helpers\Html::input(),
        ],


        [
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function(\skeeks\modules\cms\shop\models\ShopOrder $model)
            {
                $result = [];
                foreach ($model->shopBaskets as $shopBasket)
                {
                    $result[] = \yii\helpers\Html::a("[{$shopBasket->product->id}] " . $shopBasket->product->name . " ({$shopBasket->quantity} шт.)", $shopBasket->product->getPageUrl(), [
                        'data' =>
                        [
                            'pjax' => '0'
                        ],
                        'target' => '_blank',
                        'title' => 'Смотреть товар на сайте (откроется в новой вкладке)'
                    ]);
                }

                return implode('<hr style="margin-top: 5px; margin-bottom: 5px;"/>', $result);
            },
            'label' => 'Позиции',
            'format' => 'raw',
        ],


        [
            'class' => \skeeks\cms\grid\UserColumnData::className(),
            'attribute' => 'user_id',
            'label'     => 'Покупатель'
        ],

        [
            'attribute' => 'price',
            'label'     => 'Сумма',
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function(\skeeks\modules\cms\shop\models\ShopOrder $model)
            {
                return \Yii::$app->money->intlFormatter()->format($model->price());
            },
        ],

        [
            'class' => \skeeks\cms\grid\BooleanColumn::className(),
            'attribute' => 'payed',
        ],

        [
            'class' => \skeeks\cms\grid\BooleanColumn::className(),
            'attribute' => 'canceled',
        ],

        [
            'class'     => \yii\grid\DataColumn::className(),
            'value'     => function(\skeeks\modules\cms\shop\models\ShopOrder $model)
            {
                return $model->statusCode->name;
            },
            'attribute' => 'status_code',
            'label' => 'Статус',
            'filter' => \yii\helpers\ArrayHelper::map(\skeeks\modules\cms\shop\models\ShopOrderStatus::find()->all(), 'code', 'name')
        ],
    ],
]); ?>
