<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 17.03.2015
 *
 * @var $formField \skeeks\modules\cms\form\models\FormField
 * @var $model \skeeks\modules\cms\form\models\FormValidateModel
 * @var $shopPersonType \skeeks\modules\cms\shop\models\ShopPersonType
 * @var $shopPaySystems \skeeks\modules\cms\shop\models\ShopPaySystem[]
 */
use skeeks\modules\cms\form\widgets\ActiveForm;
?>
<?php $form = ActiveForm::begin([
    'modelForm'                 => $model->modelForm,
    'action'                    => \skeeks\cms\helpers\UrlHelper::construct('shop/backend/create-order')->toString(),
]);
?>


<?= \yii\helpers\Html::hiddenInput('shopPersonType', $shopPersonType->id); ?>
<? if ($shopPaySystems) : ?>
    <? if (count($shopPaySystems) == 1) : ?>
        <? $shopPaySystem = $shopPaySystems[0]; ?>
        <?= \yii\helpers\Html::hiddenInput('shopPaySystemId', $shopPaySystem->id); ?>
    <? else : ?>

        <div class="form-group field-formvalidatemodel-name">
            <label class="control-label">Система оплаты: </label>
            <?= \skeeks\widget\chosen\Chosen::widget([
                'allowDeselect' => false,
                'name'          => 'shopPaySystemId',
                'items'         => \yii\helpers\ArrayHelper::map($shopPaySystems, 'id', 'name')
            ])?>
        </div>
    <? endif; ?>
<? endif;?>


<? if ($fields) : ?>
    <? foreach ($fields as $formField) : ?>
        <?= $formField->renderActiveForm($form, $model)?>
    <? endforeach; ?>
<? endif; ?>



<?php ActiveForm::end(); ?>