<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 03.04.2015
 */
namespace skeeks\modules\cms\shop\widgets\cart;
use skeeks\cms\widgets\base\hasTemplate\WidgetHasTemplate;
use skeeks\modules\cms\shop\assets\ShopAsset;
use yii\helpers\Json;

/**
 * Class Products
 * @package skeeks\modules\cms\shop\widgets\cart
 */
class CartWidget extends WidgetHasTemplate
{
    static public $isRegisteredAssets = false;

    public $allowRegisterAsset = true;

    public function rules()
    {
        return ArrayHelper::merge(parent::rules(), [
            [['allowRegisterAsset'], 'integer']
        ]);
    }

    public function attributeLabels()
    {
        return ArrayHelper::merge(parent::attributeLabels(), [
            'allowRegisterAsset' => 'Подключить стандартные скрипты'
        ]);
    }


    /**
     * Подготовка данных для шаблона
     * @return $this
     */
    public function bind()
    {
        parent::bind();

        if (static::$isRegisteredAssets === false && $this->allowRegisterAsset)
        {
            ShopAsset::register($this->getView());
            $options = \Yii::$app->shop->getShopClientOptions();
            $options = Json::encode($options);

            $this->getView()->registerJs(<<<JS
    (function(sx, $, _)
    {
        sx.Shop = new sx.classes.shop.App($options);
    })(sx, sx.$, sx._);
JS
);
            static::$isRegisteredAssets = true;
        }

        return $this;
    }


}
