<?php
/**
 * @author Semenov Alexander <semenov@skeeks.com>
 * @link http://skeeks.com/
 * @copyright 2010 SkeekS (СкикС)
 * @date 03.04.2015
 */
namespace skeeks\modules\cms\shop\widgets\orders;

use skeeks\cms\widgets\base\hasModelsSmart\WidgetHasModelsSmart;
use skeeks\cms\widgets\base\hasTemplate\WidgetHasTemplate;
use skeeks\modules\cms\shop\assets\ShopAsset;
use skeeks\modules\cms\shop\models\ShopOrder;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;

/**
 * Class OrdersWidget
 * @package skeeks\modules\cms\shop\widgets
 */
class OrdersWidget extends WidgetHasModelsSmart
{
    public $modelClassName          = '\skeeks\modules\cms\shop\models\ShopOrder';
    public $title                   = '';
    public $user_id;

    public function rules()
    {
        return ArrayHelper::merge(parent::rules(), [
            ['user_id', 'integer']
        ]);
    }

    public function attributeLabels()
    {
        return ArrayHelper::merge(parent::attributeLabels(), [
            'user_id' => 'Пользователь'
        ]);
    }

    /**
     * Подготовка данных для шаблона
     * @return $this
     */
    public function bind()
    {
        parent::bind();

        if ($this->user_id)
        {
            $query = $this->getSearch()->getDataProvider()->query;
            $query->andWhere(['user_id' => $this->user_id]);
        }

        return $this;
    }
}
